﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LevelManagerScript : MonoBehaviour {

	public GameObject PlayerSphere;
	public GameObject[] StaticSpheres;
	public GameObject FixedSphere;
	float newAngle;
	float posXs, negXs, posYs, negYs;
	float resXVector, resYVector; // Total/Resultant X's and Y's of all StaticSpheres.
	float resFnet;
	/// </summary>
	Vector3 constantVector = new Vector3 (1, 0, 0);
	Vector3 allDirections;

	void Update () {
		newAngle = 0;	
		posXs = 0;
		posYs = 0;
		negXs = 0;
		negYs = 0;

		resXVector = 0;
		resYVector = 0;
		resFnet = 0;
		
		for (int i = 0; i < StaticSpheres.Length; i++) {

			// Gets the Fnet between a sphere and the player.
			float Fnet = (StaticSpheres [i].GetComponent<StaticSphereScript> ().Mass / DistanceSqr (StaticSpheres [i])) * 0.3f;
//			Vector3 direction = StaticSpheres [i].transform.position - PlayerSphere.transform.position;
			float angle = Vector3.Angle(StaticSpheres [i].transform.position, constantVector);		
			if (angle >= 90) {
				newAngle = 180 - angle;
			}
			float yVar = getYVector (newAngle, Fnet);
//			Debug.Log ("yVar: " + yVar);
			float xVar = PythagoreanAdj (Fnet, yVar);
//			Debug.Log ("xVar: " + xVar);
			float newFnet = PythagoreanHyp (xVar, yVar);
//			Debug.Log ("New FNet: " + newFnet);

			// Adds all positive X's together
			if (angle <= 89) {
				posXs += xVar;
				Debug.Log ("xVar =" + xVar);
//				Debug.Log("An 'X' (xVar) was added to posX");
			}
			// Adds all negative X's together
			if (angle >= 90) {
				negXs += xVar;//
				Debug.Log ("xVar =" + xVar);
//				Debug.Log("An 'X' (xVar) was added to negX");
			}
			// Adds all positive Y's together
			if (StaticSpheres [i].transform.position.y > 0) {
				posYs += yVar;
				Debug.Log ("yVar =" + yVar);
//				Debug.Log("A 'Y' (yVar) was added to posY");
			}
			// Adds all negative Y's together
			if (StaticSpheres [i].transform.position.y < 0) {
				negYs += yVar;
				Debug.Log ("yVar =" + yVar);
//				Debug.Log("A 'Y' (yVar) was added to negY");
			}		
		}
		//Debug.Log ("Pos X " +posXs);
		//Debug.Log ("Pos Y " +posYs);
		//Debug.Log ("Neg X " +negXs);
		//Debug.Log ("Neg Y " +negYs);
		resXVector = Mathf.Abs (posXs - negXs);
		resYVector = Mathf.Abs (posYs - negYs);
		resFnet = (PythagoreanHyp (resXVector, resYVector)) * 10.0f;

		Debug.Log ("resX: " +resXVector);
		Debug.Log ("resY: " +resYVector);

		//Vector3 NormalizedDirVector = NormDirVector (resXVector, resYVector);
		Vector3 NormalizedDirVector = new Vector3(resXVector, resYVector, 0.0f);
		NormalizedDirVector.Normalize ();
		Vector3 FinalDirection = QuadrantDeterminant (posXs, negXs, posYs, negYs, NormalizedDirVector.x, NormalizedDirVector.y);
		//Vector3 finalMovement = new Vector3 (FinalDirection.x, FinalDirection.y, 0.0f) * resFnet;
		Debug.Log(NormalizedDirVector);
		Debug.Log (resFnet);
		//Debug.DrawLine (PlayerSphere.transform.position, finalMovement * 100.0f, Color.red);

		PlayerSphere.transform.position += new Vector3 (FinalDirection.x, FinalDirection.y, 0.0f) * resFnet;
		//Debug.Log ("resFnet" + resFnet);
	}

	float DistanceSqr(GameObject otherPlanet) {
		float distance = Vector3.Distance (PlayerSphere.transform.position, otherPlanet.transform.position);
		return Mathf.Pow (distance, 2.0f);          
	}

	float getYVector(float newAngle, float Fnet) { //Getting a Sphere's Y Vector
		float yVar = (newAngle * Mathf.PI) / 180;
		float newFnet = Mathf.Sin(yVar) * Fnet;
		return newFnet;
	}

	float PythagoreanAdj(float a, float b) { // For Adjacent/ X force
		float pyth = (a * a) - (b * b);
		return Mathf.Sqrt (pyth);
	}

	float PythagoreanHyp(float a, float b) { // For Hypotenuse/ NewFnet
		float pyth = (a * a) + (b * b);
		return Mathf.Sqrt (pyth);
	}		

//	Vector3 CalculateNewDirection(float xVar, float yVar) {
//		float newDir = (yVar / xVar);
//		Vector3 dirVector = new Vector3 (xVar, yVar, 0);
//		Vector3 yVector = new Vector3 (0, yVar, 0);
//		float newDirec = (newDir * Mathf.Rad2Deg);
//		return (Mathf.Atan (newDir) * 180) / Mathf.PI;
//		return dirVector;
//	}

	Vector3 NormDirVector(float xVar, float yVar) {
		Vector3 normDir = new Vector3 (xVar, yVar, 0);
		return normDir;
	}

	Vector3 QuadrantDeterminant(float posX, float negX, float posY, float negY, float resXVector, float resYVector) {
		if (posYs > negYs && posXs > negXs) {
			//-x +y
			return new Vector3 ((resXVector * -1), resYVector, 0);
		}

		if (posYs < negYs && posXs < negXs) {
			//-x -y
			return new Vector3 ((resXVector * -1), (resYVector * -1), 0);
		}

		if (posXs > negXs && posYs < negYs) {
			//+x -y
			return new Vector3 (resXVector, (resYVector * -1), 0);
		}

		return new Vector3 (0, 0, 0);
	}

}