﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MouseDragScript : MonoBehaviour {

	public Transform DraggedObj;
	Ray ray;
	RaycastHit hit;
	Vector3 offset;
	public bool isDragging = false;

	void Update() {
		ray = Camera.main.ScreenPointToRay (Input.mousePosition);
		if (Physics.Raycast (ray, out hit, Mathf.Infinity)) {
			if (Input.GetMouseButtonDown (0)) {
				if (isDragging == false) {
					isDragging = true;
					DraggedObj = hit.transform;
					offset = DraggedObj.position - ray.origin;
					if (DraggedObj.tag == "Player") {
						isDragging = false;
						DraggedObj = null;
					}
				} else if (isDragging == true) {
					isDragging = false;
					DraggedObj = null;
				}
			}
			if (DraggedObj) {
				DraggedObj.transform.position = new Vector3 (ray.origin.x + offset.x, ray.origin.y + offset.y, DraggedObj.position.z);
			}
		}
	}
}
